#import "SWGDate.h"
#import "SWGLookup.h"

@implementation SWGLookup

-(id)data: (SWGDatum*) data
    status: (SWGStatus*) status
{
  _data = data;
  _status = status;
  return self;
}

-(id) initWithValues:(NSDictionary*)dict
{
    self = [super init];
    if(self) {
        id data_dict = dict[@"data"];
        if(data_dict != nil)
            _data = [[SWGDatum alloc]initWithValues:data_dict];
        id status_dict = dict[@"status"];
        if(status_dict != nil)
            _status = [[SWGStatus alloc]initWithValues:status_dict];
        

    }
    return self;
}


-(NSDictionary*) asDictionary {
    NSMutableDictionary* dict = [[NSMutableDictionary alloc] init];
    if(_data != nil){
        if([_data isKindOfClass:[NSArray class]]){
            NSMutableArray * array = [[NSMutableArray alloc] init];
            for(id data in (NSArray *)_data) {
                if ([data respondsToSelector:@selector(asDictionary)]) {
                    [array addObject:[(SWGObject *)data asDictionary]];
                } else {
                    [array addObject:data];
                }
            }
            dict[@"data"] = array;
        }
        else if([_data isKindOfClass:[SWGDate class]]) {
            NSString * dateString = [(SWGDate*)_data toString];
            if(dateString){
                dict[@"data"] = dateString;
            }
        }
        else {
            if ([_data respondsToSelector:@selector(asDictionary)]) {
                dict[@"data"] = [(SWGObject *)_data asDictionary];
            } else {
                dict[@"data"] = _data;
            }
        }
    }
    if(_status != nil){
        if([_status isKindOfClass:[NSArray class]]){
            NSMutableArray * array = [[NSMutableArray alloc] init];
            for(id status in (NSArray *)_status) {
                if ([status respondsToSelector:@selector(asDictionary)]) {
                    [array addObject:[(SWGObject *)status asDictionary]];
                } else {
                    [array addObject:status];
                }
            }
            dict[@"status"] = array;
        }
        else if([_status isKindOfClass:[SWGDate class]]) {
            NSString * dateString = [(SWGDate*)_status toString];
            if(dateString){
                dict[@"status"] = dateString;
            }
        }
        else {
            if ([_status respondsToSelector:@selector(asDictionary)]) {
                dict[@"status"] = [(SWGObject *)_status asDictionary];
            } else {
                dict[@"status"] = _status;
            }
        }
    }
    NSDictionary* output = [dict copy];
    return output;
}

@end

